/******************************************************************************/
/*                                                                            */
/*        Project: Boona Taxi                                                 */
/*          Title: GLUT callbacks header file                                 */
/*        Version: 0.3                                                        */
/*                                                                            */
/*        Started: 15/11/2000                                                 */
/*   Last Updated: 14/02/2001                                                 */
/*                                                                            */
/*        Authors: Rob Bateman, Michael Bonnington                            */
/*                                                                            */
/******************************************************************************/

/* callbacks.h : Holds register callbacks function definition.
 *               Defines window structure for use with reshape and renderer.
 *               Contains data structures for game.
 */

#ifndef CALLBACKS_H
#define CALLBACKS_H

#include "./fruity_math.h"



/* Structs ===================================================================*/
struct window{
   int width, height, pos_x, pos_y;
   char gameModeString[16];
   bool gameMode;
};
extern struct window win;


//this is only temporary at the moment...
//some of these values will need to be initialised...
class game
{
   public:

      /* Keyboard and mouse input variables... */
      bool lmb, mmb;
      int mouse_press_x, mouse_press_y;
      GLfloat spin_x, spin_y, dolly, trans_x, trans_y;


   /* Whether to display heads up display or not... */
   bool heads_up_display;

   /* Whether to use the top-down view (for testing purposes)... */
   bool top_down_view;

   int game_mode, option, cam_view;
   float game_time, counter;
   //double frametime;


      /* Constructor... */
      game(void)
      {
         //init();
      };

      /* Destructor... */
      ~game(void)
      {
      };


};

class camera
{
   public:

      float pos_x, pos_y, pos_z,
            aim_x, aim_y, aim_z,
            old_pos_x, old_pos_y, old_pos_z,
            old_aim_x, old_aim_y, old_aim_z;

      cVector3f vect;

      /* Constructor... */
      camera(void)
      {
         vect.set(aim_x-pos_x, aim_y-pos_y, aim_z-pos_z);
      };

      /* Destructor... */
      ~camera(void)
      {
      };

};



/* Function prototypes =======================================================*/
extern void registerCallbacks(void);



#endif
