#ifndef MAYA_MOUSE_H
#define MAYA_MOUSE_H


class mayaMouse
  {
    public :

      mayaMouse( void );
      void motion( int x , int y );
      void buttonPress( int button , int state , int x , int y );
      void doTransform( void );

    private:
      
      bool  bLMB,
            bMMB;

      int   iLastPosX,
            iLastPosY,
            iModifier;

      float fZoom ,
            fTransX,
            fTransY,
            fSpinX,
            fSpinY;

  } Mousey ;


mayaMouse::mayaMouse( void )
  {
    bLMB    = false;
    bMMB    = false;
    fZoom   = 0;
    fTransX = 0;
    fTransY = 0;
    fSpinX  = 0;
    fSpinY  = 0;
  }


void mayaMouse::buttonPress( int button , int state , int x , int y )

  {

    iModifier = glutGetModifiers();

    if(state == GLUT_DOWN)
      {
        iLastPosX = x; 
        iLastPosY = y;
        switch(button) 
          {
            case GLUT_LEFT_BUTTON:
              bLMB = true;
            break;
            case GLUT_MIDDLE_BUTTON:
              bMMB = true;
            break;

            default: 
            break;
          }
       }
     else
       { 
         switch(button)
           {
             case GLUT_LEFT_BUTTON:
               bLMB = false;
             break;

             case GLUT_MIDDLE_BUTTON:
               bMMB = false;
             break;

             default: 
             break;
           }
       }

     if( bLMB && bMMB )
       {
         glutSetCursor(GLUT_CURSOR_LEFT_RIGHT);
       }
     else
     if( bLMB )
       {
         #ifdef WIN32
           glutSetCursor(GLUT_CURSOR_CROSSHAIR);
         #else
           glutSetCursor(GLUT_CURSOR_CYCLE);
         #endif
       }
     else
     if( bMMB )
       {
         #ifdef WIN32
           glutSetCursor(GLUT_CURSOR_SPRAY);
         #else
           glutSetCursor(GLUT_CURSOR_CROSSHAIR);
         #endif
       }
     else
       {
         glutSetCursor(GLUT_CURSOR_INHERIT);              
       }
  }

void mayaMouse::motion( int x , int y )

  {

    int iStepX = x - iLastPosX;
    int iStepY = y - iLastPosY;

    if( iModifier == GLUT_ACTIVE_ALT )
      {
        if(bLMB && bMMB)
          {
            fZoom += 0.2*iStepX;
          }
        else
        if( bLMB )
          {
            fSpinX += 0.5*iStepY;
            fSpinY += 0.5*iStepX;
          }
        else
        if( bMMB )
          {
            fTransX  += 0.2*iStepX;
            fTransY  -= 0.2*iStepY;
          }
      }

    iLastPosX = x;
    iLastPosY = y;
  }


void mayaMouse::doTransform( void )
  {

    gluLookAt(0, 1, 50, 0, 0, 0, 0, 1, 0);

    glTranslatef( fTransX , fTransY , fZoom );
    glRotatef   ( fSpinX  , 1.0 , 0.0 , 0.0 );
    glRotatef   ( fSpinY  , 0.0 , 1.0 , 0.0 );

  }

#endif

