#include "./object_plane.h"

void cObjectPlane::setPlanes( void )

  //
  // assumes all corners of plane are right angle's
  //

  {
    midPoint = ( boundingBox[0] + boundingBox[1] )*0.5;
    uint lowest = 0,i,j;

    if( vertexArray )
      {
        float checkvals[] = { 0.0 , 0.0 , 0.0 , 0.0 };

        for( i=0; i<vertexCount; i++ )
          {
            float cur = ( vertexArray[i] - midPoint ).length();
            if( cur > checkvals[lowest] )
              {

                checkvals[lowest] = cur;
                vrefs[lowest]     =   i;

                for( j=0;j<4;j++)
                  {
                    if( checkvals[j] < checkvals[lowest] ) lowest = j;
                  }
              }
          }
      }

    // find edge pairs : start with all possiblilities, & remove 2 unusable ones

    uint edges[]        = { 0 , 1 ,
                            0 , 2 ,
                            0 , 3 ,
                            1 , 2 ,
                            1 , 3 ,
                            2 , 3 };
    float edgeLengths[6];
    uint  dontUseEdges[2];

    // work out edge lengths

    for( i=0 ; i<6; i++ )
      {
         edgeLengths[i] = (vertexArray[vrefs[edges[2*i+1]]] - vertexArray[vrefs[edges[2*i]]]).length();
      }

    // work out which two edges we should ignore

    for( i=0 , j=0; i<2; i++,j+=3 )
      {
        if( edgeLengths[j] > edgeLengths[j+1] )
          {
            if( edgeLengths[j] > edgeLengths[j+2] )
              {
                dontUseEdges[i] = j;
              }
            else dontUseEdges[i] = j+2;
          }
        else
        if( edgeLengths[j+1] > edgeLengths[j+2] )
          {
            dontUseEdges[i] = j+1;
          }
        else dontUseEdges[i] = j+2;
      }

    uint cnt=0;

    for( i=0; i<6; i++ )
      {
        if( dontUseEdges[0] != i && dontUseEdges[1] != i)
          {
            cVector3f middleOfEdge( (vertexArray[vrefs[edges[2*i+1]]] - vertexArray[vrefs[edges[2*i]]]) * 0.5);
            cVector3f norm( middleOfEdge - midPoint );
            cullEdges[cnt].setNormal( norm.normalized() );
            cullEdges[cnt].d = -(norm.normalized()*vertexArray[vrefs[edges[2*i+1]]]);
            cnt ++;
          }
      }

  }



bool cObjectPlane::load  ( char *filename )
  {
    if( !objFile::load( filename ) ) return false;

    setPlanes();

    a=triangleArray[0].a;
    b=triangleArray[0].b;
    c=triangleArray[0].c;
    d=triangleArray[0].d;
  }

bool cObjectPlane::draw( void )
  {
    objFile::draw();
    glDisable( GL_TEXTURE_2D );
    for( uint i=0 ; i< 4; i++ )
      {
        glPushMatrix();
          glColor3f( 1,1,1 );
          glTranslatev( vertexArray[ vrefs[i] ].CurrentPos );
          glutSolidCube(0.2);
        glPopMatrix();
      }
    glEnable( GL_TEXTURE_2D );
  }

bool cObjectPlane::drawReflectedInPlane ( objFile &obj )
  {
    if( obj.triangleCount == 0 ) return false;
 

	if( distance( camPos ) > 0 )
      {



        glPushMatrix();
        glBegin(GL_TRIANGLES);
        for( uint i=0; i<obj.triangleCount; i++ )
          {
                for( uint j=0; j<3; j++ )
                  {
                    
                    glTexCoord2fv( &obj.texCoordArray[ obj.triangleArray[ i ].tinds[j] ].pos[0] );
                    glColor3f    (  obj.triangleArray[ i ].colour[3*j     ], 
                                    obj.triangleArray[ i ].colour[3*j + 1 ],
                                    obj.triangleArray[ i ].colour[3*j + 2 ]);
                    glVertex3v   ( reflectPoint( obj.vertexArray[ obj.triangleArray[ i ].vinds[j] ].CurrentPos ) );
                  }
          }
        glEnd();
        glPopMatrix();
      }
    return true;
  }

