/*######################################################################
###
###   OBJECT LOADER HEADER FILE
###
######################################################################*/

#ifndef OBJLOADER_H
#define OBJLOADER_H

#include "./geometry_base.h"
#include "./fruity_exception.h"


class Vertex
  {
     public:

       float pos[3];
       float upos[3];
  };

class Normal
  {
     public:

       float pos[3];
  };

class TexCoord
  {
     public:

       float pos[2];
  };

class Triangle
  {
     public:

       uint      tinds[3] ,
                 ninds[3] ,
                 vinds[3] ;
  };


class objFile : public geometry
  {
     public:

       //
       // redeclared pure virtual functions inherited from 'geometry' class
       //

       bool load  ( char *filename );
       bool draw  ( void           );
       bool deform( float timeInc  );
 


       objFile( void ) : geometry() 
         {
           vertexCount   = 0;
           normalCount   = 0;
           texCoordCount = 0;
           triangleCount = 0;
           vertexArray   = NULL;
           normalArray   = NULL;
           texCoordArray = NULL;
           triangleArray = NULL;
           Time          = 0;
         }
       ~objFile(void);



     private:

       unsigned int    vertexCount;       //  Total Number Of Verticies
       Vertex         *vertexArray;       //  Array Of Verticies

       unsigned int    normalCount;       //  Total Number Of Normals
       Normal         *normalArray;       //  Array Of Normals

       unsigned int    texCoordCount;     //  Total Number Of TexCoords
       TexCoord       *texCoordArray;     //  Array Of TexCoords

       unsigned int    triangleCount;     //  Total Number Of Triangles
       Triangle       *triangleArray;     //  Array Of Triangles

       float Time;

  };

#endif
