#ifndef GEOMETRY_BASE_H
#define GEOMETRY_BASE_H

#include "./opengl_includes.h"
#include "./fruity_exception.h"

#include <string.h>
#include <iostream.h>
#include <fstream.h>

class geometry

  // 
  // Base geometry class used to inherit base characteristics for 
  // Polygon meshs & nurbs surfaces. Defines basic functionality
  // That geometry should have....
  //

  {
    public:
      
      virtual bool draw( void )   = 0;
      virtual bool load( char *filename )  = 0;
      virtual bool deform( float timeInc ) = 0;

      geometry( void ) { };
      ~geometry( void ) { };
  };


#endif
